#       Copyright (c) 2008 Raluca Pataliu
#
#        Permission is hereby granted, free of charge, to any person obtaining a copy
#        of this software and associated documentation files (the "Software"), to deal
#        in the Software without restriction, including without limitation the rights
#        to use, copy, modify, merge, publish, distribute, sub-license, and/or sell
#        copies of the Software, and to permit persons to whom the Software is
#        furnished to do so, subject to the following conditions:
#       
#        The above copyright notice and this permission notice shall be included in
#        all copies or substantial portions of the Software.
#       
#        THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#        IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#        FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#        AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#        LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#        OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#        THE SOFTWARE.


max = 100000.0
base = 39000.0
multiply_by = 4000
start_score = 19800

def init(p):    
    global start_score
    p.score, start_score = start_score, start_score - 0.005 
    p.wins = p.loses = 0.0    
    if (start_score < 10000): start_score = 10000
    
def calc(stats):    
    winner = stats[0]
    winner.wins += len(stats)-1
    for p in stats[1:]:
        p.loses += 1
        ratio = (base - (winner.score - p.score))/max
        
        winners_ratio = winner.wins/(winner.loses + winner.wins)
        winner.score += ratio * ((max - winner.score)/max) * winners_ratio * multiply_by
        
        losers_ratio = p.loses/(p.loses + p.wins)
        p.score -= ratio * (p.score/max) * losers_ratio * multiply_by
