#       Copyright (c) 2008 Iulian Blajut
#
#        Permission is hereby granted, free of charge, to any person obtaining a copy
#        of this software and associated documentation files (the "Software"), to deal
#        in the Software without restriction, including without limitation the rights
#        to use, copy, modify, merge, publish, distribute, sub-license, and/or sell
#        copies of the Software, and to permit persons to whom the Software is
#        furnished to do so, subject to the following conditions:
#       
#        The above copyright notice and this permission notice shall be included in
#        all copies or substantial portions of the Software.
#       
#        THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#        IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#        FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#        AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#        LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#        OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#        THE SOFTWARE.

min_score = 0.0
max_score = 1001.0

magic_number = 40.0
def_score = 201.0

count = 0


def init(p):
    """This function will be called after a Player object is created.
    You can initialize extra features here.
    You can also set a default score here."""
    global def_score
    p.score = def_score
    def_score -= 0.00005
    p.wins = 1.0
    p.loses = 1.0
        
def calc(stats):    
    global count, def_score
    count += 1    
    winner = stats[0]
    # for every loser...
    for p in stats[1:]:
        winners_ratio = winner.wins/(winner.loses + winner.wins)
        losers_ratio = p.loses/(p.loses + p.wins)
        difference_ratio = (390.0 - (winner.score - p.score))/max_score       
        
        winner.score += difference_ratio * ((max_score - winner.score)/max_score) * magic_number * winners_ratio
        
        
        p.score -= difference_ratio * (p.score/max_score) * magic_number * losers_ratio
    for p in stats:
        if p.win:
            p.wins += len(stats) - 1.0
        else:
            p.loses += 1.0
    
        
