"""
        Copyright (c) 2008 Eric Lantz

        Permission is hereby granted, free of charge, to any person obtaining a copy
        of this software and associated documentation files (the "Software"), to deal
        in the Software without restriction, including without limitation the rights
        to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
        copies of the Software, and to permit persons to whom the Software is
        furnished to do so, subject to the following conditions:

        The above copyright notice and this permission notice shall be included in
        all copies or substantial portions of the Software.

        THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
        IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
        FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
        AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
        LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
        OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
        THE SOFTWARE.
"""

PW = 9.43
K = 4.75
K2 = 7.65
K3 = 4.52
I = 1249.12
MP = 1.0659
D = 382.74
R = 19.4
R2 = 33.8

#print PW, K, K2, K3, I, MP, D, R, R2

def init(p):
    """This function will be called after a Player object is created.
    You can initialize extra features here.
    You can also set a default score here."""
    p.rounds = 0
    p.score = I

def calc(stats):
    for p in stats:
        if p.win: w,rank = p,p.score
        p.rounds += 1

    losranks = 0
    for p in stats:
        if p.win: continue
        cur = p.score
        losranks += cur
        myK = K
        if p.rounds < R: myK = K + K2 + K3
        elif p.rounds < R2: myK = K + K2
        p.score += myK*(0 - (1/(1+pow(PW,(rank-cur)/D))))
    myK = K
    if w.rounds < R: myK = K + K2 + K3
    elif w.rounds < R2: myK = K + K2
    cur = MP * losranks / (len(stats)-1)
    w.score += (len(stats)-1)*myK*(1 - (1/(1+pow(PW,(cur-rank)/D))))
