'''
Copyright (c) 2008 David Lambert (Code Penguin)

        Permission is hereby granted, free of charge, to any person obtaining a copy
        of this software and associated documentation files (the "Software"), to deal
        in the Software without restriction, including without limitation the rights
        to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
        copies of the Software, and to permit persons to whom the Software is
        furnished to do so, subject to the following conditions:
        
        The above copyright notice and this permission notice shall be included in
        all copies or substantial portions of the Software.
        
        THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
        IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
        FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
        AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
        LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
        OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
        THE SOFTWARE.


        This is a modified version of Phil Hassey's ELO implementation.
'''

def init(p):
    p.rounds = 0
    p.score = 0
    
def calcK(p):
    if p.rounds < 16:
        return 10
    elif p.score < 65:
        return 7
    elif p.score >= 65 and p.score <= 200:
        return 5
    else:
        return 3
    
def minmax(score):
    #return min(350,max(0, score))
    return max(0, score)

def calc(stats):
    for p in stats:
        if p.win: w,wscore = p,p.score
        p.rounds += 1
    
    for p in stats:
        if p.win: continue
        pscore = p.score
        p.score += calcK(p)*(0.0 - (1.0/(1.0+pow(10,(wscore-pscore)/400))))
        p.score = minmax(p.score)
        w.score += calcK(w)*(1.0 - (1.0/(1.0+pow(10,(pscore-wscore)/400))))
        w.score = minmax(w.score)