"""
Copyright (c) 2008 Bulkan Evcimen aka paulatreides

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
"""


# max score atainable
max = 25000

# minimum unit of points for beating a player in a round
u = 10

# experience percentage threshold
threshold = 0.50


def init(p):
    """This function will be called after a Player object is created.
    You can initialize extra features here.
    You can also set a default score here."""
    p.rounds = 0
    p.score = 0


def calc(stats):
    winner = stats[0]
    winner.rounds += 1

    points = 0

    for p in stats[1:]:
        p.rounds += 1

        # has the player that lost the round had more experience/rounds
        if p.rounds > winner.rounds:

            # what is the percentage difference and difference
            percent_diff =  winner.rounds / float(p.rounds)
            diff = p.rounds - winner.rounds

            if diff > 45:

                points +=  (2 * u)

                minus =  u 
                if p.score -  minus > 0:
                    p.score -= minus

            else:
                points += u

                minus =  u
                if p.score -  minus > 0:
                    p.score -= minus

        # winner won againts an inexperienced player ?
        elif p.rounds < winner.rounds:
            percent_diff =   float(p.rounds) / winner.rounds

            diff = winner.rounds - p.rounds

            if percent_diff >= threshold:
                points +=  u / 2

                minus =  u
                if p.score -  minus > 0:
                    p.score -= minus
            else:
                points += u

                minus =  u
                if p.score -  minus > 0:
                    p.score -= minus
        else:
            points += u
        
            minus =  u
            if p.score -  minus > 0:
                p.score -= minus


    if winner.score + points < max:
        winner.score += points

    # p.score is the official ranking of the player
    # and is what your algorithm is judged by
